unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, xmldom, XMLIntf, Sockets, msxmldom, XMLDoc,
  IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient, ComCtrls;

type
  TClientForm = class(TForm)
    ConnectionGroup: TGroupBox;
    HostName: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    SetUpConnection: TButton;
    FromBox: TComboBox;
    ToBox: TComboBox;
    Label3: TLabel;
    Label4: TLabel;
    ThroughBox: TComboBox;
    Label5: TLabel;
    Departure: TEdit;
    Label6: TLabel;
    MaxChanges: TSpinEdit;
    Label7: TLabel;
    SearchN: TSpinEdit;
    Label8: TLabel;
    Label9: TLabel;
    XMLDoc: TXMLDocument;
    TcpClient: TTcpClient;
    PortNumber: TSpinEdit;
    Search: TButton;
    Results: TTreeView;
    procedure SetUpConnectionClick(Sender: TObject);
    procedure SearchClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ClientForm: TClientForm;

implementation

{
//*************************************************************
 Klient

 myslenka je velmi primocara -- jedine dve dulezite udalosti
 je stisk tlacitka inicizlizace, ktere nastavi adresu a port a
 stahne seznam stanic. Pote je mozne pouzit tlacitko vyhledavani,
 ktere opet pouze posle dotaz na server a vypise vystup (po
 rozparsovani)
***************************************************************//
}



{$R *.dfm}

procedure TClientForm.SetUpConnectionClick(Sender: TObject);
var
  str: string;
  p: pchar;
  i: integer;
  f: TextFile;
  node: IXMLNode;
begin
  TcpClient.RemoteHost := HostName.Text;
  TcpClient.RemotePort := PortNumber.Text;

  if (TcpClient.Connect) then begin
    TcpClient.Open;
    str := 'GET /SeznamStanic HTTP/1.0'+#13#10#13#10;
    p := pchar(str);
    TcpClient.SendBuf(p^, length(str)+1);

    // read the server answer
    str := TcpClient.Receiveln();
    setlength(str, 12);
    if (str = 'HTTP/1.0 200') or (str = 'HTTP/1.1 200') then begin
      while str <> '' do str := TcpClient.Receiveln();
    end else begin
      MessageBox(0, 'Chybna odpoved serveru', 'Chyba', 0);
    end;

    str := ' ';
    // write the data down
    AssignFile(F, 'stanice.xml');
    Rewrite(F);
    while str <> '' do begin
      str := TcpClient.Receiveln();
      Writeln(F, str);
    end;
    CloseFile(F);
    TcpClient.Close;

    // Load the xml
    XMLDoc.LoadFromFile('stanice.xml');
    node := XMLDoc.ChildNodes.FindNode('SeznamStanic');

    for i:=0 to node.ChildNodes.Count-1 do begin
      if node.ChildNodes.Get(i).NodeName = 'Stanice' then begin
        str := node.ChildNodes.Get(i).Text;
        FromBox.Items.Add(str);
        ToBox.Items.Add(str);
        ThroughBox.Items.Add(str);
      end;
    end;
    FromBox.Enabled := true;
    TOBox.Enabled := true;
    ThroughBox.Enabled := true;
    ThroughBox.Items.Add('');

    FromBox.ItemIndex := 0;
    ToBox.ItemIndex := 1;
    ThroughBox.ItemIndex := ThroughBox.Items.Count-1;

    SetUpConnection.Default := false;
    Search.Default := true;
    Search.Enabled := true;

  end else begin
    MessageBox(0, 'Spojen se nepodailo inicializovat.', 'Chyba', 0);
  end;
end;

procedure TClientForm.SearchClick(Sender: TObject);
var
  str: string;
  p: pchar;
  i,j,k: integer;
  f: TextFile;
  node_spojeni, node_spoj, node_linka: IXMLNode;
  tree_spoj, tree_linka: TTreeNode;
  str_spoj_odjezd, str_spoj_prijezd, str_linka_odjezd, str_linka_prijezd: string;
  str_linka_odjezd_mesto, str_linka_prijezd_mesto: string;
  prestupu: integer;
begin
  if (TcpClient.Connect) then begin
    TcpClient.Open;
    str := '/NajdiSpojeni?odkud='+FromBox.Text+'&kam='+ToBox.Text +
           '&prestupy='+MaxChanges.Text+'&spojeni='+SearchN.Text;
    if (Departure.Text <> '') then begin
      str := str + '&odjezd='+Departure.Text;
    end;

    for i:= 1 to length(str) do if str[i] = ' ' then str[i] := '+';
    str := 'GET '+str+' HTTP/1.0'+#13#10#13#10;

    p := pchar(str);
    TcpClient.SendBuf(p^, length(str)+1);

    // read the server answer
    str := TcpClient.Receiveln();
    setlength(str, 12);
    if (str = 'HTTP/1.0 200') or (str = 'HTTP/1.1 200') then begin
      while str <> '' do str := TcpClient.Receiveln();
    end else begin
      MessageBox(0, 'Chybna odpoved serveru', 'Chyba', 0);
    end;

    str := ' ';
    // write the data down
    AssignFile(F, 'odpoved.xml');
    Rewrite(F);
    while str <> '' do begin
      str := TcpClient.Receiveln();
      Writeln(F, str);
    end;
    CloseFile(F);
    TcpClient.Close;
  end else begin
    MessageBox(0, 'Spojeni nenavazano!', 'Chyba', 0);
  end;

  // parse that xml results
  Results.Items.Clear;
  XMLDOc.LoadFromFile('odpoved.xml');

  str_spoj_odjezd := '';
  str_spoj_prijezd := '';
  str_linka_odjezd := '';
  str_linka_prijezd := '';
  str_linka_odjezd_mesto := '';
  str_linka_prijezd_mesto := '';
  prestupu := 0;

  // as parsing, fill the tree
  node_spojeni := XMLDoc.ChildNodes.FindNode('Spojeni');
  for i:=0 to node_spojeni.ChildNodes.Count-1 do begin
    if (node_spojeni.ChildNodes.Get(i).NodeName = 'Spoj') then begin
      node_spoj := node_spojeni.ChildNodes.Get(i);
      tree_spoj := Results.Items.AddChild(nil, '');
      for j := 0 to node_spoj.ChildNodes.Count-1 do begin
        if (node_spoj.ChildNodes.Get(j).NodeName = 'Linka') then begin
          node_linka := node_spoj.ChildNodes.Get(j);
          tree_linka := Results.Items.AddChild(tree_spoj, '');
          for k := 0 to node_linka.ChildNodes.Count-1 do begin
            if node_linka.ChildNodes.Get(k).NodeName = 'Stanice' then begin
              str := 'Stanice: '+node_linka.ChildNodes.Get(k).Text;
              if node_linka.ChildNodes.Get(k).Attributes['prijezd']<>'' then begin
                str := str + ', prijezd v '+node_linka.ChildNodes.Get(k).Attributes['prijezd'];
                str_linka_prijezd := node_linka.ChildNodes.Get(k).Attributes['prijezd'];
                str_linka_prijezd_mesto := node_linka.ChildNodes.Get(k).Text;
                str_spoj_prijezd := str_linka_prijezd;
              end;
              if node_linka.ChildNodes.Get(k).Attributes['odjezd']<>'' then begin
                str := str + ', odjezd v '+node_linka.ChildNodes.Get(k).Attributes['odjezd'];
                if str_linka_odjezd = '' then begin
                  str_linka_odjezd := node_linka.ChildNodes.Get(k).Attributes['odjezd'];
                  str_linka_odjezd_mesto := node_linka.ChildNodes.Get(k).Text;
                end;
                if str_spoj_odjezd = '' then str_spoj_odjezd := str_linka_odjezd;
              end;
              Results.Items.AddChild(tree_linka, str);
            end else if node_linka.ChildNodes.Get(k).NodeName = 'Poznamka' then begin
              Results.Items.AddChild(tree_linka, 'Poznamka: '+node_linka.ChildNodes.Get(k).Text);
            end;
          end; // k cykle
          tree_linka.Text := 'Linka c. '+node_linka.Attributes['cislo']+' odjezd v '+str_linka_odjezd+' ze stanice '+str_linka_odjezd_mesto+' a prijezd v '+str_linka_prijezd+' do stanice '+str_linka_prijezd_mesto;
          str_linka_odjezd := '';
          str_linka_prijezd := '';
          str_linka_odjezd_mesto := '';
          str_linka_prijezd_mesto := '';
          prestupu := prestupu + 1;
        end;
      end; // j cykle
    end;
    tree_spoj.Text := 'Spoj s odjezdem v '+str_spoj_odjezd+' a prijezdem v '+str_spoj_prijezd;
    if (prestupu = 1) then tree_spoj.Text := tree_spoj.Text + ', prima linka' else
      tree_spoj.Text := tree_spoj.Text + ', pocet prestupu: '+ IntToStr(prestupu-1);
    prestupu := 0;
    str_spoj_odjezd := '';
    str_spoj_prijezd := '';
  end; // i cykle

end;

end.
